
# Requires libmongocrypt including MONGOCRYPT-702.
runOn:
  - minServerVersion: "8.0.0" # Requires 8.0.0-rc14 for SERVER-91889.
    # Skip QEv2 (also referred to as FLE2v2) tests on Serverless. Unskip once Serverless enables the QEv2 protocol.
    # FLE 2 Encrypted collections are not supported on standalone.
    # Tests for Decimal (without precision) must only run against a replica set. Decimal (without precision) queries are expected to take a long time and may exceed the default mongos timeout.
    topology: [ "replicaset" ]
database_name: &database_name "default"
collection_name: &collection_name "default"
data: []
encrypted_fields: &encrypted_fields {'fields': [{'keyId': {'$binary': {'base64': 'EjRWeBI0mHYSNBI0VniQEg==', 'subType': '04'}}, 'path': 'encryptedDecimalNoPrecision', 'bsonType': 'decimal', 'queries': {'queryType': 'range', 'contention': {'$numberLong': '0'}, 'trimFactor': {'$numberInt': '1'}, 'sparsity': {'$numberLong': '1'}}}]}
key_vault_data: [ {'_id': {'$binary': {'base64': 'EjRWeBI0mHYSNBI0VniQEg==', 'subType': '04'}}, 'keyMaterial': {'$binary': {'base64': 'sHe0kz57YW7v8g9VP9sf/+K1ex4JqKc5rf/URX3n3p8XdZ6+15uXPaSayC6adWbNxkFskuMCOifDoTT+rkqMtFkDclOy884RuGGtUysq3X7zkAWYTKi8QAfKkajvVbZl2y23UqgVasdQu3OVBQCrH/xY00nNAs/52e958nVjBuzQkSb1T8pKJAyjZsHJ60+FtnfafDZSTAIBJYn7UWBCwQ==', 'subType': '00'}}, 'creationDate': {'$date': {'$numberLong': '1648914851981'}}, 'updateDate': {'$date': {'$numberLong': '1648914851981'}}, 'status': {'$numberInt': '0'}, 'masterKey': {'provider': 'local'}} ]
tests:
  - description: "FLE2 Range Decimal. Delete."
    clientOptions:
      autoEncryptOpts:
        kmsProviders:
          local: {'key': {'$binary': {'base64': 'Mng0NCt4ZHVUYUJCa1kxNkVyNUR1QURhZ2h2UzR2d2RrZzh0cFBwM3R6NmdWMDFBMUN3YkQ5aXRRMkhGRGdQV09wOGVNYUMxT2k3NjZKelhaQmRCZGJkTXVyZG9uSjFk', 'subType': '00'}}}
    operations:
      - name: insertOne
        arguments:
          document: &doc0 { _id: 0, encryptedDecimalNoPrecision: { $numberDecimal: "0" } }
      - name: insertOne
        arguments:
          document: &doc1 { _id: 1, encryptedDecimalNoPrecision: { $numberDecimal: "1" } }
      - name: deleteOne
        arguments:
            filter: { "encryptedDecimalNoPrecision": { $gt: {$numberDecimal: "0" }} }
        result:
          deletedCount: 1
    expectations:
      - command_started_event:
          command:
            listCollections: 1
            filter:
              name: *collection_name
          command_name: listCollections
      - command_started_event:
          command:
            find: datakeys
            filter: {
                  "$or": [
                      {
                          "_id": {
                              "$in": [
                                {'$binary': {'base64': 'EjRWeBI0mHYSNBI0VniQEg==', 'subType': '04'}}
                              ]
                          }
                      },
                      {
                          "keyAltNames": {
                              "$in": []
                          }
                      }
                  ]
              }
            $db: keyvault
            readConcern: { level: "majority" }
          command_name: find
      - command_started_event:
          command:
            insert: *collection_name
            documents:
              - &doc0_encrypted { "_id": 0, "encryptedDecimalNoPrecision": { $$type: "binData" } }
            ordered: true
            encryptionInformation:
              type: 1
              schema:
                default.default:
                  # libmongocrypt applies escCollection and ecocCollection to outgoing command.
                  escCollection: "enxcol_.default.esc"
                  ecocCollection: "enxcol_.default.ecoc"
                  <<: *encrypted_fields
          command_name: insert
      - command_started_event:
          command:
            insert: *collection_name
            documents:
              - &doc1_encrypted { "_id": 1, "encryptedDecimalNoPrecision": { $$type: "binData" } }
            ordered: true
            encryptionInformation:
              type: 1
              schema:
                default.default:
                  # libmongocrypt applies escCollection and ecocCollection to outgoing command.
                  escCollection: "enxcol_.default.esc"
                  ecocCollection: "enxcol_.default.ecoc"
                  <<: *encrypted_fields
          command_name: insert
      - command_started_event:
          command:
            delete: *collection_name
            deletes: [
                  {
                      "q": {
                          "encryptedDecimalNoPrecision": {
                              "$gt": {
                                  "$binary": {
                                      "base64": "[encoded data, 33832 characters]",
                                      "subType": "06"
                                  }
                              }
                          }
                      },
                      "limit": 1
                  }
              ]
            ordered: true
            encryptionInformation:
              type: 1
              schema:
                default.default:
                  # libmongocrypt applies escCollection and ecocCollection to outgoing command.
                  escCollection: "enxcol_.default.esc"
                  ecocCollection: "enxcol_.default.ecoc"
                  <<: *encrypted_fields
          command_name: delete
    outcome:
      collection:
        # Outcome is checked using a separate MongoClient without auto encryption.
        data:
         -
          {
              "_id": {
                  "$numberInt": "0"
              },
              "encryptedDecimalNoPrecision": { $$type: "binData" },
              "__safeContent__": [
                  {
                      "$binary": {
                          "base64": "rbf3AeBEv4wWFAKknqDxRW5cLNkFvbIs6iJjc6LShQY=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "n+XAuFnP8Dov9TnhGFxNx0K/MnVM9WbJ7RouEu0ndO0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "yRXojuVdn5GQtD97qYlaCL6cOLmZ7Cvcb3wFjkLUIdM=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "DuIkdRPITRs55I4SZmgomAHCIsDQmXRhW8+MOznkzSk=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "SsBk+Et1lTbU+QRPx+xyJ/jMkmfG+QCvQEpip2YYrzA=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "crCIzOd8KhHvvUlX7M1v9bhvU4pLdTc+X2SuqoKU5Ek=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "YOWdCw4UrqnxkAaVjqmC4sKQDMVMHEpFGnlxpxdaU6E=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "M3SShp81Ff8tQ632qKbv9MUcN6wjDaBReI0VXNu6Xh4=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "gzHlSPxpM0hT75kQvWFzGlOxKvDoiKQZOr19V6l2zXI=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "s3JnppOGYw9SL2Q1kMAZs948v2F5PrpXjGei/HioDWs=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "cG6+3Gk/zEH68P/uuuwiAUVCuyJwa1LeV+t29FlPPAo=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "dupdvR3AyJtM+g9NDKiaLVOtGca387JQp8w+V03m7Ig=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "JqEQc5svj2jTvZ6LLA5ivE+kTb/0aRemSEmxk4G7Zrg=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "szcXXXKnob+p3SoM4yED2R920LeJ7cVsclPMFTe4CeI=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "o1QoGVXmuBdHwHm7aCtGMlMVKrjFdYvJXpoq6uhIAZ0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "Jfm5wPlqqLCJRGQIqRq2NGmpn7s0Vrih2H3YAOoI2YU=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "zMHLb8ARbsYo8Ld05bqnGFf1Usha6EGb8QKwdSAyps0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "yQdtq9lh5pugL7/i0Bj/PuZUUBUIzf+7wj1rl5y736w=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "wGWVZdO7qIuyDg/BqDgqjgoQ02h5YYgwXQB1oCin2NE=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "by9HMLj6NTEpgztZ5HSN6GxImkXPcaFINYDzgZY33X8=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "tWo0vbasi7bXmn/MsOx13VC1IsWtpx/nYp0uj4iMzdA=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "tQQpndUYd5O87lOtrGjH3wl9VsOK0ray7RMasL90sBM=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "cQjXEDCMsOpKLLf+vlTgIHA+cbSJdzqhbSX9Wvh95aA=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "7yMpU48IxK9SzP2cx3VnTownGEwFmeFofuuFT97SuuY=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "kSOx1kz0CmBgzKQHZlo65ZUY1DIv9A99JRm+Us2y6Ew=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "ubQpdPBe6/xvtr+AcXdfYLSvYCR4ot0tivehkCsupb4=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "xal+iCJ6FTefRQToyoNksc9NCZShyn04NDGi4IYrcoM=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "d7jU4iOK50xHxlkSifcxlZFCM46TSgQzoYivxG3HNLY=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "tJvl2nsBLBVzL3pp6sKWCL4UXeh3q/roYBJjSb74ve0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "OIUCaKRvIx9t1w6Hxlz1IcQTdPNCfdRNwnnTm10W+X0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "A9tvzsiElotOUVIB4CqfQp9mAwqvTM35YkmAR170aHA=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "lI8gpK7hpb7c9x4RQugsxMnQay5LZJmwslZdvMx/dcE=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "dNCzh40U0XvdKnSDi3HRQOWQftEsDVqc4uUvsVFGoq8=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "IP+iwEBWBwVVZIdpaMu8k5+soFCz+TZkYn3drKZ9grE=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "pnqyh6e0y5svHkJDShlN9CHV0WvMBE4QbtJpQw5ZCXc=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "elEl42tbVDoRTLjAhZUFEtXiut4b3PVhg/1ZLZSQdtE=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "vHuu2FxwclMHqyE6JBYbTYgbEkB0dqb/JuaxsvfwsmY=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "xTf7NCe3Gf8QpE78HR5OknlLTKfs9J+RN9UZpH6fnso=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "XiWSasRnJAulGR6+LCVD3mwRObXylqYWR9jvpywq12c=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "MZMxEQ5ikx0PG1YFIExv0UnTZogsvgeOEZTpzvBDn4w=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "yZMyMZBDrWbAhvnic7vvIYhmO9m5H2iuv0c8KNZrBzY=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "xxM14hTPY5j0vvcK2C7YAEjzdsfUTFHozHC0hEo1bxI=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "+01rqR1xVwkpGXcstbk1ItJqFVjH6Q8MGxEN3Cm9Y1A=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "xOpLV0Z2VTRJ3iWtnWZcsyjXubTIkYWo31cO+HV1o1k=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "BWUOLqgLBqc5NwxVlSV5H3KFQPXbCp7mdo+jF+8cJqY=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "fuQb1S6xZDGlrEbK+kI23aL53PP1PVNwqICnZNt9Yzg=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "SfscnoibFttahLdPVC4Ee+47ewGFKpDSU7M6HX19bKE=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "rpSW2awybNVeKtat91VFxqbINoTfNhPfQAu+d73Xtf8=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "9M/CP9ccOIIj2LLFmE0GFDO0Ban2wsNalEXfM6+h+1s=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "WrEMG49l1ye4MhXs5ZS9tz8P6h+hDvthIg/2wW9ne1Q=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "ImNhbfeyfH8qIEeA5ic0s3dAQBdzzTBS+CPsNih9vZ0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "dWP33YDSn04UKJN2ogh2Rui0iW/0q2y18OCDRVcfyoo=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "lYv0isAtfGh6H9tdp3cp2eHU7q2J+uk7QrgcxtK3w7Y=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "VGMoamB/+7zTOYcY/pqJc96xlv2PdW4hwsIAEIslTDQ=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "yNeBWMF7BnD9wVwz2PgJsvWr77QiVvvWUvJF0+fqBug=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "SfpvObJ+tJBXSvqeN7vlOfmhYign635lciYAJIjUtY8=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "dsen4NqjzVGjpjufiTMs3+gqeD09EbnuogPgxrJECwg=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "pxCWVM3sn19NsFEpgHbgLa+PmYlhN3mMiP0Wk8kJhYw=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "q11KNvJszjYIB9n9HcC+N4uz11a3eRj1L3BH9scKMDQ=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "A1PmkgcEToWh1JiVWE6mI5jUu7poxWWuCUt/cgRUUDc=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "qJo3Hu4PJeanL7XEaWXO/n3YsodhZyd+MJOOmB9Kpd8=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "BkBKLO8URFscfRY9Bav/1+L9mLohDgNr/MkZtGiraIs=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "rZq5WA3Hx3xthOyHAJXK//f8pE2qbz7YKu3TIMp9GFY=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "X07a/Lm80p5xd4RFs1dNmw+90tmPDPdGiAKVZkxd4zY=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "6YrBn2ofIw1b5ooakrLOwF41BWrps8OO0H9WH4/rtlE=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "0l86Ag5OszXpa78SlOUV3K9nff5iC1p0mRXtLg9M1s4=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "Hn6yuxFHodeyu7ISlhYrbSf9pTiH4TDEvbYLWjTwFO0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "zdf4y2etKBuIpkEU1zMwoCkCsdisfXZCh8QPamm+drY=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "rOQ9oMdiK5xxGH+jPzOvwVqdGGnF3+HkJXxn81s6hp4=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "61aKKsE3+BJHHWYvs3xSIBvlRmKswmaOo5rygQJguUg=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "KuDb/GIzqDM8wv7m7m8AECiWJbae5EKKtJRugZx7kR0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "Q+t8t2TmNUiCIorVr9F3AlVnX+Mpt2ZYvN+s8UGict8=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "tJRZIpKxUgHyL83kW8cvfjkxN3z6WoNnUg+SQw+LK+k=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "pnUsYjip8SvW0+m9mR5WWTkpK+p6uwJ6yBUAlBnFKMk=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "PArHlz+yPRYDycAP/PgnI/AkP8Wgmfg++Vf4UG1Bf0E=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "wnIh53Q3jeK8jEBe1n8kJLa89/H0BxO26ZU8SRIAs9Q=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "4F8U59gzBLGhq58PEWQk2nch+R0Va7eTUoxMneReUIA=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "ihKagIW3uT1dm22ROr/g5QaCpxZVj2+Fs/YSdM2Noco=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "EJtUOOwjkrPUi9mavYAi+Gom9Y2DuFll7aDwo4mq0M0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "dIkr8dbaVRQFskAVT6B286BbcBBt1pZPEOcTZqk4ZcI=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "aYVAcZYkH/Tieoa1XOjE/zCy5AJcVTHjS0NG2QB7muA=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "sBidL6y8TenseetpioIAAtn0lK/7C8MoW4JXpVYi3z8=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "0Dd2klU/t4R86c2WJcJDAd57k/N7OjvYSO5Vf8KH8sw=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "I3jZ92WEVmZmgaIkLbuWhBxl7EM6bEjiEttgBJunArA=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "aGHoQMlgJoGvArjfIbc3nnkoc8SWBxcrN7hSmjMRzos=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "bpiWPnF/KVBQr5F6MEwc5ZZayzIRvQOLDAm4ntwOi8g=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "tI7QVKbE6avWgDD9h4QKyFlnTxFCwd2iLySKakxNR/I=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "XGsge0CnoaXgE3rcpKm8AEeku5QVfokS3kcI+JKV1lk=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "JQxlryW2Q5WOwfrjAnaZxDvC83Dg6sjRVP5zegf2WiM=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "YFuHKJOfoqp1iGVxoFjx7bLYgVdsN4GuUFxEgO9HJ5s=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "Z6vUdiCR18ylKomf08uxcQHeRtmyav7/Ecvzz4av3k4=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "SPGo1Ib5AiP/tSllL7Z5PAypvnKdwJLzt8imfIMSEJQ=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "m94Nh6PFFQFLIib9Cu5LAKavhXnagSHG6F5EF8lD96I=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "pfEkQI98mB+gm1+JbmVurPAODMFPJ4E8DnqfVyUWbSo=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "DNj3OVRLbr43s0vd+rgWghOL3FqeO/60npdojC8Ry/M=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "kAYIQrjHVu49W8FTxyxJeiLVRWWjC9fPcBn+Hx1F+Ss=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "aCSO7UVOpoQvu/iridarxkxV1SVxU1i9HVSYXUAeXk4=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "Gh6hTP/yj1IKlXQ+Q69KTfMlGZjEcXoRLGbQHNFo/1s=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "/gDgIFQ4tAlJk3GN48IS5Qa5IPmErwGk8CHxAbp6gs0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "PICyimwPjxpusyKxNssOOwUotAUbygpyEtORsVGXT8g=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "4lu+cBHyAUvuxC6JUNyHLzHsCogGSWFFnUCkDwfQdgI=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "pSndkmoNUJwXjgkbkgOrT5f9nSvuoMEZOkwAN9ElRaE=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "tyW+D4i26QihNM5MuBM+wnt5AdWGSJaJ4X5ydc9iWTU=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "9Syjr8RoxUgPKr+O5rsCu07AvcebA4P8IVKyS1NVLWc=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "67tPfDYnK2tmrioI51fOBG0ygajcV0pLo5+Zm/rEW7U=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "y0EiPRxYTuS1eVTIaPQUQBBxwkyxNckbePvKgChwd0M=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "NWd+2veAaeXQgR3vCvzlI4R1WW67D5YsVLdoXfdb8qg=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "PY5RQqKQsL2GqBBSPNOEVpojNFRX/NijCghIpxD6CZk=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "lcvwTyEjFlssCJtdjRpdN6oY+C7bxZY+WA+QAqzj9zg=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "CWE7XRNylvTwO/9Fv56dNqUaQWMmESNS/GNIwgBaEI0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "ijwlrUeS8nRYqK1F8kiCYF0mNDolEZS+/lJO1Lg93C8=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "8KzV+qYGYuIjoNj8eEpnTuHrMYuhzphl80rS6wrODuU=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "wDyTLjSEFF895hSQsHvmoEQVS6KIkZOtq1c9dVogm9I=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "SGrtPuMYCjUrfKF0Pq/thdaQzmGBMUvlwN3ORIu9tHU=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "KySHON3hIoUk4xWcwTqk6IL0kgjzjxgMBObVIkCGvk4=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "hBIdS9j0XJPeT4ot73ngELkpUoSixvRBvdOL9z48jY8=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "Tx6um0q9HjS5ZvlFhvukpI6ORnyrXMWVW1OoxvgqII0=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "zFKlyfX5H81+d4A4J3FKn4T5JfG+OWtR06ddyX4Mxas=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "cGgCDuPV7MeMMYEDpgOupqyNP4BQ4H7rBnd2QygumgM=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "IPaUoy98v11EoglTpJ4kBlEawoZ8y7BPwzjLYBpkvHQ=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "Pfo4Am6tOWAyZNn8G9W5HWWGC3ZWmX0igI/RRB870Ro=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "fnTSjd7bC1Udoq6iM7UDnHAC/lsIXSHp/Gy332qw+/I=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "fApBgVRrTDyEumkeWs5p3ag9KB48SbU4Si0dl7Ns9rc=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "QxudfBItgoCnUj5NXVnSmWH3HK76YtKkMmzn4lyyUYY=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "sSOvwhKa29Wq94bZ5jGIiJQGbG1uBrKSBfOYBz/oZeI=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "FdaMgwwJ0NKsqmPZLC5oE+/0D74Dfpvig3LaI5yW5Fs=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "sRWBy12IERN43BSZIrnBfC9+zFBUdvjTlkqIH81NGt4=",
                          "subType": "00"
                      }
                  },
                  {
                      "$binary": {
                          "base64": "/4tIRpxKhoOwnXAiFn1Z7Xmric4USOIfKvTYQXk3QTc=",
                          "subType": "00"
                      }
                  }
              ]
          }